"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var addons_1 = require("@storybook/addons");
var recompose_1 = require("recompose");
var emotion_theming_1 = require("emotion-theming");
var BaseComponent = function (_a) {
    var theme = _a.theme, children = _a.children;
    return (React.createElement(emotion_theming_1.ThemeProvider, { theme: theme }, children));
};
exports.ThemesProvider = recompose_1.compose(recompose_1.withState("theme", "setTheme", null), recompose_1.lifecycle({
    componentDidMount: function () {
        var _a = this.props, cb = _a.cb, setTheme = _a.setTheme, themes = _a.themes;
        var channel = addons_1.default.getChannel();
        channel.on("selectTheme", setTheme);
        if (cb) {
            channel.on("selectTheme", cb);
        }
        channel.emit("setThemes", themes);
    },
    componentWillUnmount: function () {
        var _a = this.props, cb = _a.cb, setTheme = _a.setTheme;
        var channel = addons_1.default.getChannel();
        channel.removeListener("selectTheme", setTheme);
        if (cb) {
            channel.removeListener("selectTheme", cb);
        }
    },
}), recompose_1.branch(function (props) { return !props.theme; }, recompose_1.renderNothing))(BaseComponent);
//# sourceMappingURL=ThemesProvider.js.map